var app = {};
app.wx_obj=null;
app.qq_obj=null;
app.wxPay_obj = null;
app.aliPay_obj = null;
app.getui=null;
if (config.isDev == 0) {
    app.init = function () {
            //初始化常量
            //WINDOW_HEIGHT 全局的窗口尺寸常量，不随软键盘变化
            //SERVER_STATUS 服务器状态     1正常  0离线
            //IS_ONLINE     手机网络状态   1正常  0离线
            util.setStorage("WINDOW_HEIGHT", api.winHeight);
            util.setStorage("SERVER_STATUS", 1);
            util.setStorage("IS_ONLINE", 1);
            util.ping();
            var systemType=api.systemType;
            //检查更新
//          if(systemType=="android"){
//              util.checkUpdate();
//          }

            api.addEventListener({
                name: 'offline'
            }, function (ret, err) {
                util.setStorage("SERVER_STATUS", 0);
                util.setStorage("IS_ONLINE", 0);
                api.toast({
                    msg: '网络连接已断开'
                });
            });
            api.addEventListener({
                name: 'online'
            }, function (ret, err) {
                api.toast({
                    msg: '网络连接已恢复'
                });
                util.ping();
            });
        api.setStatusBarStyle({
            style: 'dark'
        });

        };
        /*极光*/
    app.initJPush = function () {

        var ajpush = api.require('ajpush');
        ajpush.init(function (ret) {
            if (ret && ret.status) {
                //success
            }
        });
        ajpush.setListener(function (ret) {
            var id = ret.id;
            var title = ret.title;
            var content = ret.content;
            var extra = ret.extra;
        });
        if(api.systemType != 'ios') {
            api.addEventListener({
                name: 'appintent'
            }, function (ret, err) {
                if (ret && ret.appParam.ajpush) {
                    var ajpush = ret.appParam.ajpush;
                    var id = ajpush.id;
                    var content = ajpush.content;
                    var extra = ajpush.extra;
                    var info = JSON.parse(extra);
                    /*接收极光的自定义方法*/
                    var index = info.orderType;
                    //推送的信息是json {orderType:1 or 2}
                    var name = "order_list";
                    var url = "t_order/order_list.html";
                    var jsonParam = {
                        index: index
                    };
                    util.openWindow(name, url, jsonParam);
                    /*接收极光的自定义方法*/
                }
            })
        }else{
            api.addEventListener({
                name: 'noticeclicked'
            }, function(ret, err) {
                if (ret && ret.value) {
                    var ajpush = ret.value;
                    var content = ajpush.content;
                    var extra = ajpush.extra;
                    var info = JSON.parse(extra);
                    ajpush.setBadge({
						badge : 0
					});
                    /*接收极光的自定义方法*/
                    var index = info.orderType;
                    //推送的信息是json {orderType:1 or 2}
                    var name = "order_list";
                    var url = "t_order/order_list.html";
                    var jsonParam = {
                        index: index
                    };
                    util.openWindow(name, url, jsonParam);
                }
            })
        }
        api.addEventListener({
            name: 'resume'
        }, function (ret, err) {
            var ajpush = api.require('ajpush');
            ajpush.onResume();
            ajpush.resumePush(function(ret) {
                util.log(ret.status);
            });
        });
        api.addEventListener({
            name: 'pause'
        }, function (ret, err) {
            var ajpush = api.require('ajpush');
            ajpush.onPause();
        });
    };
    app.initGeTui=function(){
        app.getui = api.require('pushGeTui');
        app.getui.initialize(function (ret) {
          var value = "";
          switch (ret.type) {
              case 'cid':
                  value = 'cid:' + ret.cid;
                  break;
              case 'payload':
                  //value = 'payload:' + ret.payload;
                  //透传消息，打开页面使用这个方案
                  //数据格式{LinkID:需要打开的文章或产品ID,LinkType：文章1 产品2 订单 3}
                  var data=JSON.parse(ret.payload);
                  if(!util.isNullOrEmpty(data)){
                      console.log(JSON.stringify(data));
                      if(!util.isNullOrEmpty(data.LinkID)){
                          console.log(JSON.stringify(data.LinkID));
                          var name = "";
                          var url = "";
                          if (data.LinkType == 1) {
                              name = "detail";
                              url = "t_article/detail.html";
                          } else if(data.LinkType == 2){
                              name = "product_detail";
                              url = "t_product/product_detail.html";
                          }else{
                              name = "order_detail";
                              url = "t_order/order_detail.html";
                          }
                          var jsonParam = {
                              guid: data.LinkID,
                              OrderID:data.LinkID
                          };
                          util.openWindow(name, url, jsonParam);
                      }
                  }
                  break;
              case 'occurError':
                  value = 'occurError';
                  break;
          }
        });
    };
    app.initWX = function (callback) {
        util.showProgress();
        var wx = api.require('wx');
        //判断是否装微信
        wx.isInstalled(function (ret, err) {
            if (ret.installed) {
                //启动授权流程
                wx.auth({
                    apiKey: ''
                }, function (ret, err) {
                    if (ret.status) {
                        //获取token       
                        wx.getToken({
                            apiKey: '',
                            apiSecret: '',
                            code: ret.code
                        }, function (ret, err) {
                            if (ret.status) {
                                //获取用户信息   
                                wx.getUserInfo({
                                    accessToken: ret.accessToken,
                                    openId: ret.openId
                                }, function (ret, err) {
                                    //获取到用户信息后处理
                                    if (ret.status) {
                                        callback(ret);
                                    } else {
                                        api.toast({msg:err.code});
                                        util.log("获取微信用户信息失败" + err.code);
                                    }
                                    util.hideProgress();
                                });
                            } else {
                                util.log("获取微信token信息失败" + err.code);
                            }
                            util.hideProgress();
                        });
                    } else {
                        api.toast({msg:"微信授权失败,请重试"});
                        util.log("微信授权失败 err code " + err.code);
                    }
                    util.hideProgress();
                });
            } else {
                api.toast({msg:'当前设备未安装微信客户端，无法使用微信支付'});
            }
            util.hideProgress();
        });
    };
    /***
     * 分享网页给好友
     * @param url 网页地址
     * @param title 分享标题
     * @param description 分享简介
     * @param imgUrl 分享小图片
     * @constructor
     */
    app.QQ_ShareToFriend=function(url,title,description,imgUrl, callback){
        var qq=api.require('qq');
        qq.shareNews({
            url: url,
            title: title,
            description:description,
            imgUrl:imgUrl,
            type:"QFriend"
        }, function(ret, err) {
            if (ret.status) {
                callback(ret);
            } else {
                if(err.code == 10009){
            		api.toast({msg: "当前设备未安装QQ"});
            	}else{
                	api.toast({msg:err.code});
                }
            }
        });
    };
    /***
     * 分享网页到QQ空间
     * @param url 网页地址
     * @param title 分享标题
     * @param description 分享简介
     * @param imgUrl 分享小图片
     * @constructor
     */
    app.QQ_ShareToQZone=function(url,title,description,imgUrl, callback){
        var qq=api.require('qq');
        qq.shareNews({
            url: url,
            title: title,
            description:description,
            imgUrl:imgUrl,
            type:"QZone"
        }, function(ret, err) {
            if (ret.status) {
                callback(ret);
            } else {
            	if(err.code == 10009){
            		api.toast({msg: "当前设备未安装QQ"});
            	}else{
                	api.toast({msg:err.code});
                }
            }
        });
    };
    /***
     * 分享网页给好友
     * @param url 网页地址
     * @param title 分享标题
     * @param description 分享简介
     * @param imgUrl 分享小图片
     * @constructor
     */
    app.WX_ShareToFriend=function(url,title,description,imgUrl, callback){
        var wx = api.require('wx');
        wx.shareWebpage({
            apiKey: '',
            scene: 'session',
            title: title,
            description: description,
            thumb: imgUrl,
            contentUrl: url
        }, function(ret, err) {
            if (ret.status) {
            	callback(ret);
            } else {
                api.toast({msg:err.code});
            }
        });
    };
    /***
     * 分享网页到朋友圈
     * @param url 网页地址
     * @param title 分享标题
     * @param description 分享简介
     * @param imgUrl 分享小图片
     * @constructor
     */
    app.WX_ShareToFriendGroup=function(url,title,description,imgUrl, callback){
        var wx = api.require('wx');
        wx.shareWebpage({
            apiKey: '',
            scene: 'timeline',
            title: title,
            description: description,
            thumb: imgUrl,
            contentUrl: url
        }, function(ret, err) {
            if (ret.status) {
            	callback(ret);
            } else {
                api.toast({msg:err.code});
            }
        });
    };
    //使用 app.initWxPAY();
    //app.WxPay('order_Description','str_price','orderSN',function(ret,err){}) ;
    app.initWxPAY = function () {
        app.wxPay_obj = api.require('wxPay');
        app.wxPay_obj.config({
            apiKey: config.wxpay_apiKey,
            mchId: config.wxpay_mchId,
            partnerKey: config.wxpay_partnerKey,
            notifyUrl: config.wxpay_notifyUrl
        }, function (ret, err) {
            if (ret.status) {
            } else {
                util.log("微信支付配置初始化失败");
                api.toast({msg:err.code});
            }
            console.log(JSON.stringify(err));
        });
    };
    app.WxPay = function (description, totalFee, tradeNo, callback) {
        var totalFee = String(totalFee);
        app.wxPay_obj.pay({
            description: description,
            totalFee: totalFee,
            tradeNo: tradeNo,
        }, callback);
    };
    app.initAliPay = function () {
        app.aliPay_obj = api.require('aliPay');
        app.aliPay_obj.config({
            partner: config.alipay_pid,
            seller: config.alipay_seller_id,
            rsaPriKey: config.alipay_rsaPriKey,
            rsaPubKey: config.alipay_rsaPubKey,
            notifyURL: config.alipay_notifyURL
        }, function (ret, err) {
            if (ret.status) {} else {
                util.log("支付宝支付配置初始化失败");
                api.toast({msg:err.code});
            }
        });
    };
    app.AliPay = function (description, totalFee, tradeNO, callback) {
        var totalFee = String(totalFee);
        app.aliPay_obj.pay({
            subject: description,
            body: '圆轱辘转转APP订单',
            amount: totalFee,
            tradeNO: tradeNO
        }, callback);
    };
    app.initHuanXin = function () {
        huanxin = api.require('huanxin');
        var param = {
            appkey: "yuanshiren#youxianweini"
        };
        huanxin.init(param);
        huanxin.registerReceiver();
        huanxin.registerNewMessageBroadcastReceiver(function (ret, err) {
            alert("新消息收到" + JSON.stringify(ret));
            if (ret.status == 'onReceive') {
                api.sendEvent({
                    name: 'reciveMsg',
                    extra: {
                        msgId: ret.msgId
                    }
                });
            } else {
                util.log("环信收到错误信息 " + err + " " + ret.status);
            }
        });
        huanxin.setAppInited();
    };
    app.getHuanxinMsg = function (msgId, callback) {
        huanxin = api.require('huanxin');
        huanxin.getMessage({
            msgId: ret.msgId
        }, callback);
    };
    app.loginHuanXin = function (user) {
        huanxin = api.require('huanxin');
        huanxin.login({
            username: user.username,
            pwd: '123456'
        }, function (ret, err) {
            if (ret) {
                alert(JSON.stringify(ret));
            } else {
                util.log('环信登录失败' + err);
                alert(JSON.stringify(err));
            }
        });
    };
    app.logoutHuanXin = function () {
        huanxin = api.require('huanxin');
        huanxin.logout(function (ret, err) {
            if (ret.status == "onSuccess") {
                alert(JSON.stringify(ret));
            } else if (ret.status == "onError") {
                util.log('环信注销失败' + err);
                alert(JSON.stringify(err));
            }
        });
    };
    app.Hx_sendText = function (text) {
        huanxin = api.require('huanxin');
        huanxin.sendTextMessage({
            chatType: 'CHAT',
            toUser: 'admin',
            content: text
        }, function (ret, err) {
            if (ret.status == 'progress') {} else if (ret.status == 'success') {
                alert("发送成功" + JSON.stringify(ret));
            }
        });
    };
    app.Hx_sendImage = function (imgPath) {
        huanxin = api.require('huanxin');
        huanxin.sendImageMessage({
            chatType: 'CHAT',
            toUser: 'admin',
            imagePath: img
        }, function (ret, err) {
            if (ret.status == 'progress') {} else if (ret.status == 'success') {
                alert("发送成功" + JSON.stringify(ret));
            }
        });
    };
    app.Hx_sendVoice = function (voicePath, duration) {
        huanxin = api.require('huanxin');
        huanxin.sendVoiceMessage({
            chatType: 'CHAT',
            toUser: 'admin',
            duration: duration,
            voicePath: voicePath
        }, function (ret, err) {
            if (ret.status == 'progress') {} else if (ret.status == 'success') {
                alert("发送成功" + JSON.stringify(ret));
            }
        });
    };
    app.setLogin = function (User) {
        //var ajpush = api.require('ajpush');
        //var param = {
        //    alias: Customer.CustomerPhone
        //};
        //ajpush.bindAliasAndTags(param, function (ret) {
        //    var statusCode = ret.statusCode;
        //});

        var getui = api.require('pushGeTui');
        var param = {alias:User.Account};
        getui.bindAlias(param, function (ret) {});

        util.setPreferences("UserID", User.UserID);
        util.setPreferences("UserAccount", User.Account);
        api.sendEvent({
            name: 'freshCustomerData'
        });
    };
    app.logout = function () {
        //var ajpush = api.require('ajpush');
        //var param = {
        //    alias: ''
        //};
        //ajpush.bindAliasAndTags(param, function (ret) {
        //    var statusCode = ret.statusCode;
        //});

        var getui = api.require('pushGeTui');
        var param = {alias:''};
        getui.unBindAlias(param, function (ret) {});

        util.setPreferences('UserID', '');
        util.setPreferences('UserAccount', '');
        //刷新用户中心
        api.sendEvent({
            name: 'reloadUC'
        });
        //刷新INDEX信箱
        api.sendEvent({
            name: 'SyncReds',
            extra: {
                redCount: 0
            }
        });
    };
    app.checkLogin = function () {
        var is_login = util.getPreferences("UserID");
        if (is_login != '') {
            return;
        }
        api.sendEvent({
            name: 'change_root_index',
            extra: {
                index: 4
            }
        });
        api.sendEvent({
            name: 'reloadUC'
        });

        api.closeToWin({
            name: 'root'
        });
    };
    app.addFrameCart = function (guid) {
        api.openFrame({
            name: 'frame_cart',
            url: '../t_goods/frame_cart.html',
            rect: {
                x: 0,
                y: 0,
                w: api.winWidth,
                h: api.winHeight
            },
            pageParam: {
                guid: guid
            },
            bounces: false,
            bgColor: 'rgba(0,0,0,0)',
            vScrollBarEnabled: false,
            hScrollBarEnabled: true,
        });
    };
}