/**
 * Created with JetBrains WebStorm.
 * User: yuki
 * Date: 2015-07-08
 *
 * 动态化的购物车动画
 * 将事件对象传入购物车的动画,也可用于垃圾桶 ：P
 * @param   targetID  指定的购物车ID或垃圾桶ID
 *
 * html 部分  暂无要求
 *
 * $("img").moveItemToCart();
 * $("img").moveItemToCart({ targetID: "dustbin"});
 */


(function ($) {
    $.fn.extend({
        moveItemToCart: function (options) {
			var defaults ={
                targetID: "cartBox"
            };
			var opts = $.extend(defaults, options);
            return this.each(function () {
                var item=$(this);
                var positionY = item.offset().top;
	            var positionX = item.offset().left;
                var cloneItem=item.clone(false);
                cloneItem.css({
                    "position": "absolute",
                    "z-index": "500",
                    "left": '35%',
                    "top": positionY + "px"
                });
                $('body').after(cloneItem);
                cloneItem.animate({
                    "left": '35%',
                    "width": "80px",
                    "height": "80px",
                    "borderRadius":'50%'
                },
                50,
                function() {
                    cloneItem.animate({
                        "left": $("#"+opts.targetID).offset().left + "px",
                        "top": $("#"+opts.targetID).offset().top + "px",
                        "width": "10px",
                        "height": "10px"
                    },500).fadeOut("fast",function(){$(this).remove();})
                });  
            });
        }
    })
})(jQuery);